<?php

namespace Slovocast\Domain;

/**
 * Base Repository Interfade that defines very simple versions of the CRUD
 * methods. Most Repositories will implement these methods with overrides for
 * their entities, plus more Domain specific methods.
 */ 
interface RepositoryInterface
{
    public function get(int|string $id): object;
    public function create(object $entity): object;
    public function update(object $entity): bool;
    public function delete(object $entity): bool;
}
